Index: /main/trunk/greenstone3/web/WEB-INF/classes/interface_default.properties
===================================================================
--- /main/trunk/greenstone3/web/WEB-INF/classes/interface_default.properties	(revision 25456)
+++ /main/trunk/greenstone3/web/WEB-INF/classes/interface_default.properties	(revision 25457)
@@ -22,4 +22,5 @@
 help_b=Help
 pref_b=Preferences
+debuginfo_b=Debug info
 login_b=Login
 logout_b=Logout
@@ -29,4 +30,5 @@
 help_tip=Help pages
 pref_tip=Change your interface preferences
+debuginfo_tip=Display debug view options
 login_tip=Login
 logout_tip=Logout
@@ -368,2 +370,14 @@
 dse.untitled_section=UNTITLED SECTION
 dse.insert_new_section=Insert new section
+
+###################
+# DebugInfo  #
+###################
+debuginfo.usage=When debugging the XSLT, you can append any of the following to the URL (prefixed with a & or ? as appropriate) to see the intermediate XML that's produced.
+debuginfo.xml=Displays the raw information coming from the Message Router.
+debuginfo.xmlfinal=Displays the information coming from the Message Router after the second config_format pass.
+debuginfo.skindoc=Simplified Skin XSL with Expanded GSF statements appended.
+debuginfo.skinandlib=An XML document with a root element called skinAndLibraryXsl and the two children skinXsl and libraryXsl. The libraryXsl, which already includes util.xsl, is merely appended.
+debuginfo.skinandlibdoc=The result of applying preprocess.xsl to skinandlib produces this stylesheet which is the final XSL document that will be applied to the XML data returned from the message router.
+debuginfo.formatedit=Web interface editor for editing Greenstone3 format statements.
+
Index: /main/trunk/greenstone3/web/interfaces/oran/interfaceConfig.xml
===================================================================
--- /main/trunk/greenstone3/web/interfaces/oran/interfaceConfig.xml	(revision 25456)
+++ /main/trunk/greenstone3/web/interfaces/oran/interfaceConfig.xml	(revision 25457)
@@ -4,4 +4,5 @@
       <subaction name='home' xslt='pages/home.xsl'/>
       <subaction name='about' xslt='pages/about.xsl'/>
+      <subaction name='debuginfo' xslt='pages/debuginfo.xsl'/>
       <subaction name='pref' xslt='pages/pref.xsl'/>
       <subaction name='help' xslt='pages/help.xsl'/>
Index: /main/trunk/greenstone3/web/interfaces/oran/style/core.css
===================================================================
--- /main/trunk/greenstone3/web/interfaces/oran/style/core.css	(revision 25456)
+++ /main/trunk/greenstone3/web/interfaces/oran/style/core.css	(revision 25457)
@@ -762,4 +762,8 @@
 }
 
+dl dt { font-weight:bold;
+      padding-top:10px; }
+dl dd { padding-bottom:10px}
+
 /*
 ul.childrenlist li {
Index: /main/trunk/greenstone3/web/interfaces/oran/transform/layouts/header.xsl
===================================================================
--- /main/trunk/greenstone3/web/interfaces/oran/transform/layouts/header.xsl	(revision 25456)
+++ /main/trunk/greenstone3/web/interfaces/oran/transform/layouts/header.xsl	(revision 25457)
@@ -299,4 +299,16 @@
 				</xsl:choose>
 			</li>
+			<!-- debuginfo -->
+			<xsl:if test="/page/pageRequest/paramList/param[(@name='debuginfo') and (@value='on' or @value='true' or @value='1')]">
+			  <li class="ui-state-default ui-corner-all">
+			    <a href="{$library_name}/collection/{$collNameChecked}/page/debuginfo">
+			      <xsl:attribute name="title"><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'debuginfo_tip')"/></xsl:attribute>
+			      <ul>
+				<li><span><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'debuginfo_b')"/></span></li>
+				<li><span class="ui-icon ui-icon-info"><xsl:text> </xsl:text></span></li>
+			      </ul>
+			    </a>
+			  </li>
+			</xsl:if>
 		</ul>
 	</xsl:template>
Index: /main/trunk/greenstone3/web/interfaces/oran/transform/pages/debuginfo.xsl
===================================================================
--- /main/trunk/greenstone3/web/interfaces/oran/transform/pages/debuginfo.xsl	(revision 25457)
+++ /main/trunk/greenstone3/web/interfaces/oran/transform/pages/debuginfo.xsl	(revision 25457)
@@ -0,0 +1,42 @@
+<?xml version="1.0" encoding="ISO-8859-1"?>
+<xsl:stylesheet version="1.0"
+	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
+	xmlns:java="http://xml.apache.org/xslt/java"
+	xmlns:util="xalan://org.greenstone.gsdl3.util.XSLTUtil"
+	xmlns:gslib="http://www.greenstone.org/skinning"
+	extension-element-prefixes="java util"
+	exclude-result-prefixes="java util">
+
+	<!-- use the 'main' layout -->
+	<xsl:include href="layouts/main.xsl"/>
+
+	<!-- set page title -->
+	<xsl:template name="pageTitle"><gslib:collectionName/></xsl:template>
+
+	<!-- set page breadcrumbs -->
+	<xsl:template name="breadcrumbs"><gslib:siteLink/><gslib:rightArrow/></xsl:template>
+
+	<!-- the page content -->
+	<xsl:template match="/page">
+	  <p><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'debuginfo.usage')"/></p>
+
+	  <dl>
+	    <dt>o=xml</dt>
+	    <dd><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'debuginfo.xml')"/></dd>
+	    <dt>o=xmlfinal</dt>
+	    <dd><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'debuginfo.xmlfinal')"/></dd>
+	    <dt>o=skindoc</dt>
+	    <dd><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'debuginfo.skindoc')"/></dd>
+	    <dt>o=skinandlib</dt>
+	    <dd><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'debuginfo.skinandlib')"/></dd>
+	    <dt>o=skinandlibdoc</dt>
+	    <dd><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'debuginfo.skinandlibdoc')"/></dd>
+	    <dt>formatedit=on</dt>
+	    <dd><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'debuginfo.formatedit')"/></dd>
+	  </dl>	  
+
+	</xsl:template>
+
+
+</xsl:stylesheet>  
+